﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ThrowInExpression {

	class Person {
		public string Name;
	}

	class Program {
		static void PrintPersonNameCSharp7(Person p) {
			var name = p != null ? p.Name : throw new ArgumentNullException(nameof(p));
			Console.WriteLine($"Name: {name ?? throw new ArgumentNullException(nameof(p) + "." + nameof(p.Name))}");
		}

		static void Main(string[] args) {
			var p = new Person();
			p.Name = "Pavel";

			// p = null;
			// p.Name = null;
			PrintPersonNameCSharp7(p);

			PrintPersonNameGoodOldCSharp(p);
		}

		static void PrintPersonNameGoodOldCSharp(Person p) {
			if (p == null) throw new ArgumentNullException(nameof(p));
			if (p.Name == null) throw new ArgumentNullException(nameof(p) + "." + nameof(p.Name));

			Console.WriteLine($"Name: {p.Name}");
		}
	}

	//
	// Using throw expression "correctly" - nice pattern: [a = b] ?? [throw ...] -> [target scenario] ?? [exceptional scenario]
	//

	class Student {
		public string FirstName { get; }
		public string LastName { get; }

		public Student(string firstName, string lastName) {
			FirstName = firstName ?? throw new ArgumentNullException(nameof(firstName));
			LastName = lastName ?? throw new ArgumentNullException(nameof(lastName));
		}
	}
}
